<?php

namespace v1\controllers;

use common\data\Respuesta;
use common\rest\AuthController;
use common\rest\JsonController;

class RecursoManifiestoTipoController extends AuthController {

  public function actionIndex() {
    $dias = intval($this->req->get('dias', ''));
    $estatus = trim($this->req->get('estatus', ''));

    $tipos = [
      ["id" => 1, "label" => "Aclaración Preventiva", "dias" => 5, "tipo" => "Prevención"],
      ["id" => 2, "label" => "Cierre de Instrucción", "dias" => 60, "tipo" => "Cierre de Instrucción"],
      ["id" => 3, "label" => "Desechamiento", "dias" => 60, "tipo" => "Desechado"],
      ["id" => 4, "label" => "Informe Justificado", "dias" => 7, "tipo" => "Admitir"],
      ["id" => 5, "label" => "Manifestación", "dias" => 60, "tipo" => "Ninguno"],
      ["id" => 6, "label" => "Resolución", "dias" => 60, "tipo" => "Resolución"],
    ];

    $tiposFiltrados = [];
    foreach($tipos as $elemento) {
      if ($elemento['dias'] >= $dias && ($elemento['tipo'] === $estatus || $elemento['tipo'] === 'Ninguno')) {
        $tiposFiltrados[] = $elemento;
      }
    }

    return (new Respuesta($tiposFiltrados))
      ->mensaje("RecursoManifiestoTipo");
  }
}