<?php

namespace v1\models;

use app\models\Aclaracion as ModelsAclaracion;

class Aclaracion extends ModelsAclaracion {

  public function fields () {
    return[
      'id',
      'idSolicitud',
      'idSolicitaAclaracion',
      'idAclarador',
      'solicitado',
      'aclarado',
      'tipo',
      'solicitudAclaracion',
      'aclaracion',
      'creado',
      'modificado',
      'eliminado',
      'tipoAclaracion',
    ];
  }

  public function extraFields () {
    return[
      'aclaracionMedia',
      'media',
      'aclarador',
      'solicitaAclaracion',
      'solicitud'
    ];
  }

  public function getAclaracionMedia() {
    return $this->hasMany(AclaracionMedia::class, ['idAclaracion' => 'id']);
  }

  public function getMedia() {
    return $this->hasMany(Media::class, ['id' => 'idMedia'])
      ->viaTable('AclaracionMedia', ['idAclaracion' => 'id'], function ($query) {
        $query->andWhere(['eliminado' => null]);
      });
  }

  public function getAclarador() {
    return $this->hasOne(Usuario::class, ['id' => 'idAclarador']);
  }

  public function getSolicitaAclaracion() {
    return $this->hasOne(Usuario::class, ['id' => 'idSolicitaAclaracion']);
  }

  public function getSolicitud() {
    return $this->hasOne(Solicitud::class, ['id' => 'idSolicitud']);
  }
}