<?php

namespace v1\models;

use app\models\BitacoraEstatus as ModeloBitacoraEstatus;

class BitacoraEstatus extends ModeloBitacoraEstatus {

	public function fields() {
		return [
      'id',
      'idSolicitud',
      'estatusInicial',
      'fechaCambio',
      'estatusFinal',
      'idUsuario',
      'ip',
      'notificado',
      'creado',
      'modificado',
      'eliminado',
      'idSujetoObligado',
      'declinado',
      'idUsuarioDeclina',
      'comentario',
      'idEstatusIncompetencia',
      'idEstatusNegativa',
		];
	}

	public function extraFields() {
		return [
      'estatusNuevo',
      'estatusAnterior',
      'estatusIncompetencia',
      'estatusNegativa',
      'solicitud',
      'sujetoObligado',
      'usuario',
      'usuarioDeclina',
      'mediaBitacoraEstatuses',
      'media',
		];
	}

  public function getEstatusNuevo() {
    return $this->hasOne(Estatus::class, ['id' => 'estatusFinal']);
  }

  public function getEstatusAnterior() {
    return $this->hasOne(Estatus::class, ['id' => 'estatusInicial']);
  }

  public function getEstatusIncompetencia() {
    return $this->hasOne(Estatus::class, ['id' => 'idEstatusIncompetencia']);
  }

  public function getEstatusNegativa() {
    return $this->hasOne(Estatus::class, ['id' => 'idEstatusNegativa']);
  }

  public function getSolicitud() {
    return $this->hasOne(Solicitud::class, ['id' => 'idSolicitud']);
  }

  public function getSujetoObligado() {
    return $this->hasOne(SujetoObligado::class, ['id' => 'idSujetoObligado']);
  }

  public function getUsuario() {
    return $this->hasOne(Usuario::class, ['id' => 'idUsuario']);
  }

  public function getUsuarioDeclina() {
    return $this->hasOne(Usuario::class, ['id' => 'idUsuarioDeclina']);
  }

  public function getMediaBitacoraEstatuses() {
    return $this->hasMany(MediaBitacoraEstatus::class, ['idBitacoraEstatus' => 'id']);
  }

  public function getMedia() {
    return $this->hasMany(Media::class, ['id' => 'idMedia'])
      ->viaTable('MediaBitacoraEstatus', ['idBitacoraEstatus' => 'id']);
  }
}
