<?php

namespace v1\models;

use app\models\Estado as ModeloEstado;

class Estado extends ModeloEstado {

	public function fields() {
		return [
			'id',
			'nombre',
			'idPais',
			'creado',
			'modificado',
			'eliminado',
			'clave',
		];
	}

	public function extraFields() {
		return [
			'pais',
			'municipios',
			'particulares'
		];
	}

	public function getPais() {
		return $this->hasOne(Pais::class, ['id' => 'idPais']);
	}

	public function getMunicipios() {
		return $this->hasMany(Municipio::class, ['idEstado'  => 'id']);
	}

	public function getParticulares() {
		return $this->hasMany(Particular::class, ['idEstado'  => 'id']);
	}
}
