<?php

namespace v1\models;

use app\models\Estatus as ModelsEstatus;

class Estatus extends ModelsEstatus {

  public function fields () {
    return[
      'id',
      'nombre',
      'dias',
      'descripcion',
      'idEstatusPadre',
      'creado',
      'modificado',
      'eliminado',
      'tipo',
    ];
  }

  public function extraFields () {
    return[
      'subestatus',
      'estatusPadre',
      'solicitudes',
    ];
  }

  public function getEstatusNuevo() {
    return $this->hasOne(Estatus::class, ['id' => 'estatusFinal']);
  }

  public function getEstatusAnterior() {
    return $this->hasOne(Estatus::class, ['id' => 'estatusInicial']);
  }

  public function getSubestatus() {
    return $this->hasMany(Estatus::class, ['idEstatusPadre' => 'id']);
  }

  public function getEstatusPadre() {
    return $this->hasOne(Estatus::class, ['id' => 'idEstatusPadre']);
  }

  public function getSolicitudes() {
    return $this->hasMany(Solicitud::class, ['idEstatus' => 'id']);
  }
}