<?php

namespace v1\models;

use app\models\Mensaje as ModeloMensaje;

class Mensaje extends ModeloMensaje {

	public function fields() {
		return [
			'id',
			'idUsuarioRemitente',
			'idUsuarioDestinatario',
			'idSolicitud',
			'idRecursoRevision',
			'tipo',
			'titulo',
			'mensaje',
			'respuesta',
			'visto',
			'idEstatus',
			'creado',
			'modificado',
			'eliminado',
		];
	}

	public function extraFields() {
		return [
			'estatus',
			'recursoRevision',
			'solicitud',
			'destinatario',
			'remitente',
			'media',
		];
	}

	public function getEstatus() {
		return $this->hasOne(Estatus::class, ['id' => 'idEstatus']);
	}

	public function getRecursoRevision() {
		return $this->hasOne(RecursoRevision::class, ['id' => 'idRecursoRevision']);
	}

	public function getSolicitud() {
		return $this->hasOne(Solicitud::class, ['id' => 'idSolicitud']);
	}

	public function getUsuarioDestinatario() {
		return $this->hasOne(Usuario::class, ['id' => 'idUsuarioDestinatario']);
	}

	public function getUsuarioRemitente() {
		return $this->hasOne(Usuario::class, ['id' => 'idUsuarioRemitente']);
	}

	public function getMedia() {
		return $this->hasMany(Media::class, ['id' => 'idMedia'])->viaTable('MensajeMedia',['idMensaje' => 'id']);
	}
}
