<?php

namespace v1\models;

use app\models\RecursoManifestacion as ModelsRecursoManifestacion;

class RecursoManifestacion extends ModelsRecursoManifestacion {

  public function fields () {
    return[
      'id',
      'idEmisor',
      'idSolicitud',
      'idRecurso',
      'tipo',
      'idEstatusActualRecurso',
      'mensaje',
      'creado',
      'modificado',
      'eliminado',
      'idEstatusNuevoRecurso',
      'idPonencia',
    ];
  }

  public function extraFields () {
    return[
      'emisor',
      'estatusActualRecurso',
      'estatusNuevoRecurso',
      'ponencia',
      'media',
      'solicitud',
      'recurso',
      'manifestacionMedia',
    ];
  }

  public function getEmisor() {
    return $this->hasOne(Usuario::class, ['id' => 'idEmisor']);
  }

  public function getEstatusActualRecurso() {
    return $this->hasOne(Estatus::class, ['id' => 'idEstatusActualRecurso']);
  }

  public function getEstatusNuevoRecurso() {
    return $this->hasOne(Estatus::class, ['id' => 'idEstatusNuevoRecurso']);
  }

  public function getPonencia() {
    return $this->hasOne(Ponencia::class, ['id' => 'idPonencia']);
  }

  public function getRecurso() {
    return $this->hasOne(RecursoRevision::class, ['id' => 'idRecurso']);
  }

  public function getSolicitud() {
    return $this->hasOne(Solicitud::class, ['id' => 'idSolicitud']);
  }

  public function getRecursoManifestacionMedia() {
    return $this->hasMany(RecursoManifestacionMedia::class, ['idRecursoManifestacion' => 'id']);
  }

  public function getMedia() {
    return $this->hasMany(Media::class, ['id' => 'idMedia'])
      ->viaTable('RecursoManifestacionMedia', ['idRecursoManifestacion' => 'id'], function ($query) {
        $query->andWhere(['eliminado' => null]);
      });
  }
}