<?php

namespace v1\models;

use app\models\RecursoRevision as ModeloRecursoRevision;

class RecursoRevision extends ModeloRecursoRevision {

	public function fields() {
		return [
			'id',
			'idSolicitud',
			'actoImpugnado',
			'idMotivoIncoformidad',
			'razonesMotivos',
			'documentoAnexo',
			'creado',
			'modificado',
			'eliminado',
			'documentoAnexoOtro',
			'folio',
      'idPonencia',
			'diasTranscurridos',
			'diasRestantes',
      'idEstatus',
			'fechaAmpliacion',
			'diasAmpliacion',
			'tipo',
		];
	}

	public function extraFields() {
		return [
			'estatus',
			'motivoInconformidad',
			'ponencia',
			'solicitud',
			'recursoRevisionMedia',
			'media',
			'ultimoManifiesto',
		];
	}

	public function getEstatus() {
    return $this->hasOne(Estatus::class, ['id' => 'idEstatus']);
  }

	public function getMotivoInconformidad() {
		return $this->hasOne(MotivosInconformidad::class, ['id' => 'idMotivoIncoformidad']);
	}

	public function getPonencia() {
    return $this->hasOne(Ponencia::class, ['id' => 'idPonencia']);
  }

	public function getSolicitud() {
		return $this->hasOne(Solicitud::class, ['id' => 'idSolicitud']);
	}

	public function getRecursoRevisionMedia() {
		return $this->hasMany(RecursoRevisionMedia::class, ['idRecursoRevision' => 'id']);
	}

	public function getMedia() {
		return $this->hasMany(Media::class, ['id' => 'idMedia'])
			->via('recursoRevisionMedia');
	}

	public function getUltimoManifiesto() {
    return $this->hasOne(RecursoManifestacion::class, ['idRecurso' => 'id'])->orderBy(['creado' => SORT_DESC]);
  }
}
