<?php

namespace v1\models;

use app\models\SolicitudAcuse as ModeloSolicitudAcuse;

class SolicitudAcuse extends ModeloSolicitudAcuse {

	public function fields() {
		return [
			'id',
			'folioTransaccion',
			'idSolicitud',
			'idSolicitante',
			'idSujetoObligado',
			'acuse',
			'enviado',
			'modificado',
			'eliminado',
		];
	}

	public function extraFields() {
		return [
			'solicitante',
			'solicitud',
			'sujetoObligado',
			'media',
			'solicitudAcusePersonas',
		];
	}

	public function getSolicitante() {
		return $this->hasOne(Usuario::class, ['id' => 'idSolicitante']);
	}

	public function getSolicitud() {
		return $this->hasOne(Solicitud::class, ['id' => 'idSolicitud']);
	}

	public function getSujetoObligado() {
		return $this->hasOne(SujetoObligado::class, ['id' => 'idSujetoObligado']);
	}

	public function getMedia() {
		return $this->hasMany(Media::class, ['id' => 'idMedia'])->viaTable('SolicitudAcuseMedia', ['idSolicitudAcuse' => 'id']);
	}

	public function getSolicitudAcusePersonas() {
		return $this->hasMany(SolicitudAcusePersonas::class, ['idSolicitud' => 'id']);
	}
}
