<?php

namespace v1\models;

use app\models\SujetoObligado as ModelsSujetoObligado;

class SujetoObligado extends ModelsSujetoObligado {

  public function fields() {
    return [
      'id',
      'nombre',
      'sigla',
      'idCategoria',
      'idEstado',
      'nombreEstado',
      'region',
      'secretaria',
      'orden',
      'mision',
      'ordenInforme',
      'correoInstitucional',
      'estatus',
      'creado',
      'modificado',
      'eliminado',
      'clave',
      'secuencialSolicitud',
    ];
  }

  public function extraFields() {
    return [
      'categoria',
      'estado',
      'solicitudes',
      'usuarios'
    ];
  }

  public function getCategoria() {
    return $this->hasOne(Categoria::class, ['id' => 'idCategoria']);
  }

  public function getEstado() {
    return $this->hasOne(Estado::class, ['id' => 'idEstado']);
  }

  public function getSolicitudes() {
    return $this->hasMany(Solicitud::class, ['idSujetoObligado' => 'id']);
  }

  public function getUsuarios() {
    return $this->hasMany(Usuario::class, ['idSujetoObligado' => 'id']);
  }
}
